<?xml version="1.0" encoding="utf-8"?>
<!--									-->
<!--	Formatting quizzes in Mooshak 			zp@ncc.up.pt	-->
<!--							2005		-->
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" version="4.01" encoding="utf-8"
		doctype-public= "-//W3C//DTD HTML 4.01 Transitional//EN"
		doctype-system="http://www.w3.org/TR/html4/loose.dtd"
		indent="yes"
  />
  <xsl:strip-space elements="*" />

<xsl:param name="print" select="'no'"/>

<xsl:template match="/">
<html>
	<head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
        <meta http-equiv="Expires" content="0"/>
	<title>	Mooshak Quiz </title>
	<link rel="stylesheet" href="../../styles/base.css" type="text/css"/>

	<script language="JavaScript" src="../../styles/timer.js"></script>
	<script language="JavaScript" src="../../styles/quiz.js"></script>

	<style>	
	body { padding: 10pt; }
	div.header {
		width: 		95%; 
		height: 	110px; 
		border: 	1pt; 
		border-style: 	solid; 
		padding:	10pt;
	}
	div.command {
		text-align: 	right;
		width: 		85%; 
		padding: 	2mm;
	}
	</style>
	</head>
	<body>	

	<xsl:choose>
		<xsl:when test="$print = 'yes'">
		  	<xsl:apply-templates select="quiz" mode="print"/>
		</xsl:when>
		<xsl:otherwise>
		  	<xsl:apply-templates select="quiz" mode="screen"/>
		</xsl:otherwise>
	</xsl:choose>

	</body>
</html>	
</xsl:template>


<xsl:template match="quiz[//type='empty']" mode="screen">
      	      <form name="quiz" method="post" action="."
	      	onSubmit="return confirm('Terminar a avaliação?');">

	      <xsl:apply-templates select="header"/>
	      <div class="command">
		      <input type="submit" value="Submeter"/>
		      <input type="hidden" name="Problem" value="A"/>
		      <input type="hidden" name="command" value="grade"/>
	      </div>
	      <div style="overflow: scroll; width: 95%; height: 35em;">
	      <xsl:apply-templates select="quizGroup"/>
	      </div>

	      </form>
	      <script language="JavaScript">
	      setAction("quiz")
	      </script>
</xsl:template>


<xsl:template match="quiz[//type='answered']"  mode="screen">
      	      <form name="logout" method="post" action=".">

	      <xsl:apply-templates select="header"/>
	      <div class="command">
		      <input type="submit" value="Sair"/>
		      <input type="hidden" name="command" value="logout"/>
	      </div>
	      <xsl:apply-templates select="quizGroup"/>

	      <script language="JavaScript">
	      setAction("logout")
	      </script>
	      </form>		   
</xsl:template>


<xsl:template match="quiz[//type='answered']" mode="print">
	      <xsl:apply-templates select="header"/>

	      <xsl:apply-templates select="quizGroup"/>
</xsl:template>


<xsl:template match="header">
	      <div class="header">
	      <strong>Exame: </strong><xsl:value-of select="designation"/><br/>
	      <strong>Aluno: </strong> <xsl:value-of select="student"/><br/>
	      <div style="height: 2em;">
		      <xsl:apply-templates select="type"/>
	      </div>
	      </div>
</xsl:template>

<xsl:template match="type[text() = 'empty']">

<form name="theTimer">
<input type="text" name="theTime" size="8"/> 
<xsl:text>   </xsl:text>
<img name="redImg" src="../../icons/red.gif" border="0" height="10" width="0"/><img name="greenImg" src="../../icons/green.gif" border="0" height="10" width="500"/>

</form>

<form name="missing">
Faltam <input type="text" name="total" value="0" size="2"/> perguntas. 
<xsl:text>  </xsl:text><xsl:text>  </xsl:text><xsl:text>  </xsl:text>
Perguntas em falta 
<select size="1" name="questions" onChange="jumpMissing(this);">
<option> * escolha pergunta * </option>
</select>
</form>

<script language="JavaScript">
	<xsl:variable name="duration" select="//duration"/>
	SetWakeup(disableEditing);
	SetTimer(
		<xsl:value-of select="substring-before($duration,':')"/>,
		<xsl:value-of select="substring-after($duration,':')"/>,
		0);
	Start(); 
</script>

</xsl:template>


<xsl:template match="type[text() = 'answered']">

  <b>Valorização</b>: <xsl:value-of select="../value"/><br/> 
  <b>Correcção</b>: as afirmações correctas estão destacadas a <b>negrito</b>
  e as erradas estão <s>cortadas</s>. 
  <xsl:if test="$print = 'yes'">
  	<br/>Assinatura: <hr/>
  </xsl:if>
</xsl:template>


<xsl:template match="quizGroup">
	      <h3><xsl:number/>. <xsl:value-of select="@title"/> <!-- [valor: <xsl:value-of select="@value"/>] --> </h3>

	      <blockquote>
	      <xsl:apply-templates select="quizQuestion"/>
	      
	      </blockquote>
</xsl:template>


<xsl:template match="quizQuestion">

	<xsl:variable name="ref"><xsl:number value="count(../preceding-sibling::node()) "/>.<xsl:number/>.</xsl:variable>
	<xsl:if test="$print = 'no'">
		<script language="JavaScript">
			declareMissing("<xsl:value-of select='$ref'/>");
		</script>
	</xsl:if>
	      <a name="{$ref}"/>	      
	      <strong> <xsl:value-of select="$ref"/>
	      - <xsl:copy-of select="ask/*|ask/text()"/> 
	      <!-- [valor: <xsl:value-of select="@value"/>] -->
	      </strong> 
	      <blockquote>
	      	<xsl:apply-templates select="quizChoice"/> 
	      </blockquote>
</xsl:template>

<xsl:template match="quizChoice[//type='answered']">

	     [<xsl:choose>
	 	<xsl:when test="@selected = 'true'">
			  <xsl:text>x</xsl:text>
		</xsl:when>
		<xsl:otherwise>
			  <xsl:text>  </xsl:text>
		</xsl:otherwise>
		</xsl:choose>]
	    <xsl:choose>
	    <xsl:when test="@status='right'">
	    		    <b><xsl:copy-of select="text()|*"/></b>
	     </xsl:when>
	    <xsl:when test="@status='wrong'">
			    <s><xsl:copy-of select="text()|*"/></s>
	     </xsl:when>
	     <xsl:otherwise>
			    <xsl:copy-of select="text()|*"/> 
	     </xsl:otherwise>
	   </xsl:choose>



	<br/>
</xsl:template>

<xsl:template match="quizChoice[//type='empty']">
	<xsl:variable name="ref"><xsl:number
	value="count(../../preceding-sibling::node()) "/>.<xsl:number value="count(../preceding-sibling::node())+1"/>.</xsl:variable>

	      	       <input 
		       		name="{@xml:id}" 
		       		type="checkbox" 
				value="true"
				onClick="markAsMissing('{$ref}',this.checked)"
			>		
			<xsl:if test="@selected = 'true' ">
				<xsl:attribute name="checked"/>
			</xsl:if>
			</input>
			<xsl:copy-of select="text()|*"/>

			<br/>
</xsl:template>

</xsl:transform>
